package cn.iocoder.yudao.module.other.controller.admin;

import cn.hutool.core.collection.CollUtil;
import cn.iocoder.yudao.framework.common.pojo.CommonResult;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;
import cn.iocoder.yudao.framework.excel.core.util.ExcelUtils;
import cn.iocoder.yudao.module.other.entity.DlRepairOther;
import cn.iocoder.yudao.module.other.service.DlRepairOtherService;
import cn.iocoder.yudao.module.other.vo.DlRepairOtherReqVO;
import cn.iocoder.yudao.module.other.vo.DlRepairOtherRespVO;
import cn.iocoder.yudao.module.other.vo.OtherExportVO;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.v3.oas.annotations.Operation;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletResponse;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.stream.Collectors;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception0;
import static cn.iocoder.yudao.framework.common.pojo.CommonResult.success;

/**
 * 维修附加内容表(DlRepairOther)表控制层
 *
 * @author 小李
 * @date 14:29 2024/9/21
**/
@RestController
@RequestMapping("/repair/other")
public class DlRepairOtherController {
    /**
     * 服务对象
     */
    @Resource
    private DlRepairOtherService dlRepairOtherService;

    /**
     * 新增、修改维修附加内容表
     *
     * @author 小李
     * @date 15:16 2024/9/21
     * @param repairOtherRespVO 请求对象
    **/
    @PostMapping("/update")
    @Operation(summary = "新增、修改维修附加内容表")
    public CommonResult<?> updateOther(@RequestBody DlRepairOtherRespVO repairOtherRespVO){
        dlRepairOtherService.updateOther(repairOtherRespVO);
        return CommonResult.ok();
    }

    /**
     * 维修附加内容表 分页
     *
     * @author 小李
     * @date 15:20 2024/9/21
     * @param repairOtherReqVO 请求对象
     * @param pageNo 页码
     * @param pageSize 条数
    **/
    @GetMapping("/page")
    @Operation(summary = "维修附加内容表 分页")
    public CommonResult<?> getOtherPage(DlRepairOtherReqVO repairOtherReqVO,
                                        @RequestParam(value = "pageNo", defaultValue = "1")Integer pageNo,
                                        @RequestParam(value = "pageSize", defaultValue = "1")Integer pageSize){
        Page<DlRepairOther> page = new Page<>(pageNo, pageSize);
        return success(dlRepairOtherService.getOtherPage(repairOtherReqVO, page));
    }

    /**
     * 维修附加内容表 删除
     *
     * @author 小李
     * @date 15:24 2024/9/21
     * @param id 删除记录ID
    **/
    @DeleteMapping("/delete")
    @Operation(summary = "维修附加内容表 删除")
    public CommonResult<?> deleteOther(@RequestParam("id") String id){
        dlRepairOtherService.deleteOther(id);
        return CommonResult.ok();
    }

    @GetMapping("/getByName")
    @Operation(summary = "根据名称获取最新的数据")
    public CommonResult<?> getOtherByName(@RequestParam("name") String name){
        List<DlRepairOther> list = dlRepairOtherService.list(new LambdaQueryWrapper<DlRepairOther>().eq(DlRepairOther::getName, name));
        return success(list.stream().max(Comparator.comparing(DlRepairOther::getCreateTime)).orElse(null));
    }

    /**
     * 导出数据
     *
     * @author 小李
     * @date 16:39 2024/12/2
     * @param repairOtherReqVO 请求对象
    **/
    @GetMapping("/export")
    @Operation(summary = "导出数据")
    public void exportData(DlRepairOtherReqVO repairOtherReqVO, HttpServletResponse response) throws IOException {
        int pageNo = 1, pageSize = 1000;
        List<OtherExportVO> list = new ArrayList<>();
        Page<DlRepairOther> page = new Page<>(pageNo, pageSize);
        do {
            IPage<DlRepairOther> otherPage = dlRepairOtherService.getOtherPage(repairOtherReqVO, page);
            List<DlRepairOther> records = otherPage.getRecords();

            if (CollUtil.isEmpty(records)){
                break;
            }

            List<OtherExportVO> convertedRecords = records.stream()
                    .map(item -> BeanUtils.toBean(item, OtherExportVO.class))
                    .collect(Collectors.toList());
            list.addAll(convertedRecords);

            pageNo++;
            page.setCurrent(pageNo);
        } while (true);

        if (CollUtil.isEmpty(list)){
            throw exception0(500, "没有数据可以导出");
        }

        ExcelUtils.write(response, "附加数据.xls", "数据", OtherExportVO.class, list);
    }
}

